# foundation-utils

工作中使用到的 util 方法

## number

- __Thousands(num:string)__ //千分位格式化  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;Thousands(100000) => 100,100

- __FormatMoney(num: number, decimal?: number)__ //金额格式化  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;FormatMoney(100000, 2) => 100,100.00

- __MoneyUnitSwitch(value: number, baseUnit: number, NaNText)__  

- __FormatFloat(num: number, decimal?: number)__ //格式化数据，保留指定位数小数  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;FormatFloat(0.12345, 3) => 0.123

- __NumberCheck(num: string | number)__  

- __FilterNum(num: string)__  

- __FilterNumber(num: string)__  

- __NumberToCapital(num: string | number)__ //金额转换为大写  
示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;__NumberToCapital(123) => 一百二十三圆整

- __NumberScientificNotation(num_str: string)__ //科学计数法  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;NumberScientificNotation(12E3) => 1-3  

- __Decimal_zeroFilling(num: number | string)__ //小数位补零  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;Decimal_zeroFilling(12) => 1-__00  

## object

- __IsArr(value: any)__ //数组校验  

- __IsNonEmpty(value: string)__ //非空校验  

- __IsNonZero(value: string)__ //非0校验  

- __DeleteObjKeys(obj: Object, key: string | string[])__ //删除 obj 中指定的元素  

- __RepeatObj(arr: any[], arg: string)__ //数组对象去重  

## date

- __DateFormat_YMD_HMS(nS?: Number | string, reg?: string)__ //年月日 时分秒  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;DateFormat_YMD_HMS(date, '-') => 2023-01-01 00:00:00  

- __DateFormat_YMD(nS?: Number | string, reg?: string)__ //年月日  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;DateFormat_YMD(date, '-') => 2023-01-01  

- __DateFormat_HMS(nS?: Number | string)__ //时分秒  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;DateFormat_HMS(date, '-') => 00:00:00  

- __DateFormat_timestamp(timestamp?: number | string)__ //时间戳转换为 xx天xx小时xx分钟xx秒  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;DateFormat_timestamp(new Date().getTime())  => 2天18小时02分20秒  

- __DateFormat_nextDate(date?: string, nextDay?: number, reg?: string)__ //指定日期后的几天  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;DateFormat_nextDate('2023-01-01', 2, '-') => 2023-01-03  

## download

- __FileDownload(fileUrl: string, fileName?: string)__ //文件下载 -  a 标签方式  

- __IframeDownload(fileUrl: string)__ //文件下载 - iframe 方式  

- __BlobFileDownload(fileUrl: string, fileName?: string)__ //文件下载 -  blob 方式  

- __BlobDownloadByFileUrl(fileUrl: string, fileName?: string)__ //文件下载 - blob 方式 (pdf、mp4 文件流下载)

- __BlobDownloadByBlob(blob: Blob, fileName?: string)__ //blob 文件下载  

## file

- __GetFileSuffix(fileUrl: string)__ //获取文件后缀名  

- __FileIconFormat(fileName: string)__ //文件类型判断  

## localStorage

- __SetLocalStorage(key: string, value: any)__ //存储localStorage  

- __GetLocalStorage(key: string)__ //获取localStorage  

- __RemoveLocalStorage(key: string)__ //删除localStorage  

- __RemoveLocalStorageAll()__ //删除所有localStorage  

## loadScript

- __LoadScript(url: string, callback: Function)__ //动态加载一个远程脚本  

- __LoadScriptQueue(urls: string[], cb: Function)__ //顺序加载一组远程脚本  

## url

- __ObjToUrlParam(obj: Object)__ //对象转换url参数 遇到属性值为空或0就不拼接  

- __AddUrlParamFromObj(url: string, obj: Object)__ //给url添加参数 通过对象  

- __AnalyzingUrl(url: string)__ //解析地址参数  

- __EncodeURIComponent(url: string)__ //编码  

- __DecodeURIComponent(url: string)__ //解码  

## RandomCode

- __CreateGuid()__ //Guid  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;CreateGuid() => "a1ca0f7b-51bd-4bf3-a5d5-6a74f6adc1c7"  

- __CreateRandomCode(num: number)__ //随机验证码  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;CreateRandomCode(6) => "a1ca0f"  

## copy

- __DisabledCopy()__ //禁用复制  

- __LaunchCopy()__ //关闭禁用复制  

- __CopyContent(value:string)__ //复制字符串文档至剪贴板  
  示例:  
    &nbsp;&nbsp;&nbsp;&nbsp;CopyContent('这里是需要复制的内容')  

## other

- __Debounce(func: Function, delay: number)__ //防抖函数  

- __Throttle(func: Function, wait: number)__ //节流函数  

- __StrIpScript(value: string)__ //限制输入逗号  

- __AuthorityComparison()__ //权限对比  

- __AddIframeDom(url)__ //添加iframe到文档中  

- __PrintImage(url)__ //打印图片  

- __FilterTreeNode(tree, childKey, filterKey, value)__ //树数据过滤  

## Validator 数据校验

示例：

      //import Validator from "./validator.ts"
      function requiredVerify(item): String | null {
        let validator = new Validator();
        validator.add(item.name, [
          { strategy: "isNonEmpty", errorMsg: "请输入用户名" },
          { strategy: "minLength:6", errorMsg: "用户名长度不能小于6位" },
          { strategy: "maxLength:10", errorMsg: "用户名长度不能大于10位" },
          { strategy: "maxLength:10", errorMsg: "用户名长度不能大于10位" },
          { regExp: new RegExp(''), strategy: "isCustom", errorMsg: "这里是自定义校验的错误提示信息" },
        ]);
        let errorMsg = validator.start();
        return errorMsg;
      }

## nc 观察者模式

示例：observer.ts文件

      import { NotificationCenter, Event,  } from "../nc/index";
      import type { Class } from "../nc/index";
      let nc_ = new NotificationCenter();
      // 事件名称
      export class changeEvent extends Event { }
      
      // 事件注册
      export function registerObServerEvent(that: object | symbol, eventName: Class<Event>, callback: Function) {
        nc_.register(that, eventName, async (event: Event) => {
          callback(event);
        });
      }
      
      // 事件销毁
      export function unRegisterObServerEvent(that: object | symbol, eventName: Class<Event>) {
        nc_.unRegister(that, eventName);
      }
      
      // 销毁所有事件
      export function unregisterAllObServerEvent(that: object | symbol) {
        nc_.unRegisterAll(that);
      }
      
      // 发送事件
      export function postObServerEvent(event: Event) {
        nc_.post(event);
      }

使用：index.vue文件

      postObServerEvent(new LetterStatusChangeEvent()); // 广播事件
      registerObServerEvent(proxy!.$el, LetterStatusChangeEvent, () => { loadData(); }); // 接收事件
      unRegisterObServerEvent(proxy!.$el, LetterStatusChangeEvent); // 销毁事件

git地址：git+<https://gitlab.com/liujie_project/foundation-utils.git>
